Skip to content

Creates a new billing run record that does not already exist.

Request

This method will auto-generate an ID and create a new billing run. If an ID is specified for the billing run, an error will be thrown.

Security
knox-authorizer
Path
tenantIdstringrequired

The id of the tenant being accessed.

Bodyapplication/jsonrequired

The billing run that you would like to be saved.

activate_applicationsboolean(Activate Applications)

If set, this billing run should activate all applications that have met all requirements

application_activation_optionsobject(Application Activation Options)required
application_expiration_optionsobject(Application Expiration Options)required
application_reminder_optionsobject(Application Reminder Options)required
bill_training_providersboolean(Bill Training Providers)

When true, training providers should be sent invoices for training registrations

drop_optionsobject(Drop Options)required
errorstring(Error)

The error message

error_stackstring(Error Stack)

The error stack

expire_applicationsboolean(Expire Applications)

If set, applications that are past their expiration date are expired

forecast_renewalsboolean(Forecast Renewals)

Whether this billing run should be issuing renewal forecasts

idstring(ID)^[\w|-]+$required

The unique, string identifier of this billing run

last_refresh_datestring, (date-time)(Last Refresh Date)

The last time the billing run was refreshed

namestring(Name)required

The name of the billing run

notification_emailstring(Notification Email)

Te address to send notifications

perform_dropsboolean(Perform Drops)

Whether this template should be dropping expired members

preprocessing_datestring, (date-time)(Preprocessing Date)

The date this billing run was actually processed

recurring_billing_run_idstring(Recurring Billing Run)

The recurring billing run

renewal_forecasting_optionsobject(Renewal Forecasting Options)required
renewal_reminder_optionsobject(Renewal Reminder Options)required
run_datestring, (date-time)(Run Date)

The date of the billing run

scheduled_preprocessing_datestring, (date-time)(Scheduled Preprocessing Date)

The date which this billing run should be preprocessed

scheduled_run_datestring, (date-time)(Scheduled Run Date)

The date the billing run is scheduled for execution

send_application_remindersboolean(Send Application Reminders)

If set, this billing run should send out application reminders to applications missing requirements and approaching expiration

send_renewal_remindersboolean(Send Renewal Reminders)

If set, this billing run should send out renewal reminders to those approaching expiration

statisticsArray of objects
statusstring(Status)required
Enum:"cancelled""completed""draft""error""preprocessing""ready for execution""running""scheduled""scheduled for execution""timed out"
sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

template_idstring(Template)

The billing template that created this run

training_provider_billing_optionsobject(Training Provider Billing Options)required
curl -i -X POST \
  'https://docs.api.rhythmsoftware.com/_mock/apis/certifications/certifications-v1/billingRuns/{tenantId}' \
  -H 'Authorization: Bearer <YOUR_JWT_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "activate_applications": true,
    "application_activation_options": {
      "application_notice_id": "string",
      "application_types": [
        "certification"
      ],
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "restrict_application_types": true,
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "application_expiration_options": {
      "application_notice_id": "string",
      "application_types": [
        "certification"
      ],
      "expiration_date_range_end": "2019-08-24",
      "expiration_date_range_start": "2019-08-24",
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "restrict_application_types": true,
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "application_reminder_options": {
      "application_types": [
        "certification"
      ],
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "reminders": [
        {
          "expiration_date_range_end": "2019-08-24",
          "expiration_date_range_start": "2019-08-24",
          "id": 0.1,
          "name": "string",
          "reminder_notice_id": "string"
        }
      ],
      "restrict_application_types": true,
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "bill_training_providers": true,
    "drop_options": {
      "drop_notice_id": "string",
      "expiration_date_range_end": "2019-08-24",
      "expiration_date_range_start": "2019-08-24",
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "error": "string",
    "error_stack": "string",
    "expire_applications": true,
    "forecast_renewals": true,
    "id": "string",
    "last_refresh_date": "2019-08-24T14:15:22Z",
    "name": "string",
    "notification_email": "string",
    "perform_drops": true,
    "preprocessing_date": "2019-08-24T14:15:22Z",
    "recurring_billing_run_id": "string",
    "renewal_forecasting_options": {
      "expiration_date_range_end": "2019-08-24",
      "expiration_date_range_start": "2019-08-24",
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "renewal_reminder_options": {
      "application_types": [
        "certification"
      ],
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "reminders": [
        {
          "expiration_date_range_end": "2019-08-24",
          "expiration_date_range_start": "2019-08-24",
          "id": 0.1,
          "name": "string",
          "reminder_notice_id": "string"
        }
      ],
      "restrict_application_types": true,
      "restrict_status_reasons": true,
      "status_reason_ids": [
        "string"
      ],
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    },
    "run_date": "2019-08-24T14:15:22Z",
    "scheduled_preprocessing_date": "2019-08-24T14:15:22Z",
    "scheduled_run_date": "2019-08-24T14:15:22Z",
    "send_application_reminders": true,
    "send_renewal_reminders": true,
    "statistics": [
      {
        "action": "string",
        "error": 0.1,
        "excluded": 0.1,
        "pending": 0.1,
        "processing": 0.1,
        "successful": 0.1,
        "total": 0.1
      }
    ],
    "status": "cancelled",
    "sys_bulk_load_at": "string",
    "sys_bulk_load_id": "string",
    "sys_bulk_load_pk": "string",
    "sys_bulk_load_record_no": 0.1,
    "sys_bulk_load_source_file": "string",
    "sys_calculated_field_error": "string",
    "sys_calculated_field_errors": [
      {
        "error": "string",
        "field": "string"
      }
    ],
    "sys_configuration_snapshot_id": "string",
    "sys_created_at": "2019-08-24T14:15:22Z",
    "sys_created_by_id": "string",
    "sys_deleted_by_id": "string",
    "sys_directive": "string",
    "sys_external_id": "string",
    "sys_has_files_in_s3": true,
    "sys_last_bulk_data_operation_id": "string",
    "sys_last_bulk_data_operation_sys_version": "string",
    "sys_last_modified_at": "2019-08-24T14:15:22Z",
    "sys_last_modified_by_id": "string",
    "sys_last_security_context": {},
    "sys_locked": true,
    "sys_snapshot_base_version": 0.1,
    "sys_version": 0.1,
    "template_id": "string",
    "training_provider_billing_options": {
      "email_invoices_to_training_providers": true,
      "expiration_date_range_end": "2019-08-24",
      "expiration_date_range_start": "2019-08-24",
      "invoice_template_id": "string",
      "payment_terms_id": "string",
      "program_ids": [
        "string"
      ],
      "program_restriction": "exclude",
      "training_provider_ids": [
        "string"
      ],
      "training_provider_restriction": "exclude"
    }
  }'

Responses

The billing run was saved successfully.

Headers
Access-Control-Allow-Headersstring
Access-Control-Allow-Methodsstring
Access-Control-Allow-Originstring
Bodyapplication/json
activate_applicationsboolean(Activate Applications)

If set, this billing run should activate all applications that have met all requirements

application_activation_optionsobject(Application Activation Options)required
application_expiration_optionsobject(Application Expiration Options)required
application_reminder_optionsobject(Application Reminder Options)required
bill_training_providersboolean(Bill Training Providers)

When true, training providers should be sent invoices for training registrations

drop_optionsobject(Drop Options)required
errorstring(Error)

The error message

error_stackstring(Error Stack)

The error stack

expire_applicationsboolean(Expire Applications)

If set, applications that are past their expiration date are expired

forecast_renewalsboolean(Forecast Renewals)

Whether this billing run should be issuing renewal forecasts

idstring(ID)^[\w|-]+$required

The unique, string identifier of this billing run

last_refresh_datestring, (date-time)(Last Refresh Date)

The last time the billing run was refreshed

namestring(Name)required

The name of the billing run

notification_emailstring(Notification Email)

Te address to send notifications

perform_dropsboolean(Perform Drops)

Whether this template should be dropping expired members

preprocessing_datestring, (date-time)(Preprocessing Date)

The date this billing run was actually processed

recurring_billing_run_idstring(Recurring Billing Run)

The recurring billing run

renewal_forecasting_optionsobject(Renewal Forecasting Options)required
renewal_reminder_optionsobject(Renewal Reminder Options)required
run_datestring, (date-time)(Run Date)

The date of the billing run

scheduled_preprocessing_datestring, (date-time)(Scheduled Preprocessing Date)

The date which this billing run should be preprocessed

scheduled_run_datestring, (date-time)(Scheduled Run Date)

The date the billing run is scheduled for execution

send_application_remindersboolean(Send Application Reminders)

If set, this billing run should send out application reminders to applications missing requirements and approaching expiration

send_renewal_remindersboolean(Send Renewal Reminders)

If set, this billing run should send out renewal reminders to those approaching expiration

statisticsArray of objects
statusstring(Status)required
Enum:"cancelled""completed""draft""error""preprocessing""ready for execution""running""scheduled""scheduled for execution""timed out"
sys_bulk_load_atstring(Sys Bulk Load At)

If this record was loaded via bulk, the timestamp when the record was processed

sys_bulk_load_idstring(Sys Bulk Load)

If this record was loaded via bulk, the ID of the bulk load process

sys_bulk_load_pkstring(Sys Bulk Load Pk)

If this record was loaded via bulk, the tenant and key of the bulk load process used as a partition key

sys_bulk_load_record_nonumber, (float)(Sys Bulk Load Record No)

If this record was loaded via bulk, the record number in the source file

sys_bulk_load_source_filestring(Sys Bulk Load Source File)

If this record was loaded via bulk, the source file

sys_calculated_field_errorstring(Sys Calculated Field Error)

The error associated with the calculated field

sys_calculated_field_errorsArray of objects
sys_configuration_snapshot_idstring(Sys Configuration Snapshot)

If a snapshot was restored/applies to this record, the ID of the snapshot

sys_created_atstring, (date-time)(Sys Created At)required

The date/time that this record was created, expressed in ISO-8601 date format

sys_created_by_idstring(Sys Created By)required

The ID of the user that created this record

sys_deleted_by_idstring(Sys Deleted By)

The ID of the user that deleted (or last tried to delete) this object

sys_directivestring(Sys Directive)

Means for passing directive information into an object processing logic

sys_external_idstring(Sys External)

The ID that a record has from an external system or data import

sys_has_files_in_s3boolean(Sys Has Files In S3)

If true, this record has files in S3. If false, it doesnt, so no need to hit S3 upon deletion

sys_last_bulk_data_operation_idstring(Sys Last Bulk Data Operation)

If this record was last touched by a bulk data operation, the ID of that operation

sys_last_bulk_data_operation_sys_versionstring(Sys Last Bulk Data Operation Sys Version)

If this record was last touched by a bulk data operation, the sys_version at the time of that operation

sys_last_modified_atstring, (date-time)(Sys Last Modified At)required

The date/time that this record record was last modified, expressed in ISO-8601 date format

sys_last_modified_by_idstring(Sys Last Modified By)required

The ID of the user that last modified this record

sys_last_security_contextobject(Sys Last Security Context)

The security context of the last insert, modify, or delete performed on this item

sys_lockedboolean(Sys Locked)

If set, this record is locked and cannot be changed via the API

sys_snapshot_base_versionnumber, (float)(Sys Snapshot Base Version)

The version to use as a base when creating a configuration snapshot; if not set, 1 is used. Helpful when creating a sandbox

sys_versionnumber, (float)(Sys Version)

A number representing the version of this record in the database

template_idstring(Template)

The billing template that created this run

training_provider_billing_optionsobject(Training Provider Billing Options)required
Response
{ "activate_applications": true, "application_activation_options": { "application_notice_id": "string", "application_types": [ … ], "program_ids": [ … ], "program_restriction": "exclude", "restrict_application_types": true, "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "application_expiration_options": { "application_notice_id": "string", "application_types": [ … ], "expiration_date_range_end": "2019-08-24", "expiration_date_range_start": "2019-08-24", "program_ids": [ … ], "program_restriction": "exclude", "restrict_application_types": true, "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "application_reminder_options": { "application_types": [ … ], "program_ids": [ … ], "program_restriction": "exclude", "reminders": [ … ], "restrict_application_types": true, "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "bill_training_providers": true, "drop_options": { "drop_notice_id": "string", "expiration_date_range_end": "2019-08-24", "expiration_date_range_start": "2019-08-24", "program_ids": [ … ], "program_restriction": "exclude", "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "error": "string", "error_stack": "string", "expire_applications": true, "forecast_renewals": true, "id": "string", "last_refresh_date": "2019-08-24T14:15:22Z", "name": "string", "notification_email": "string", "perform_drops": true, "preprocessing_date": "2019-08-24T14:15:22Z", "recurring_billing_run_id": "string", "renewal_forecasting_options": { "expiration_date_range_end": "2019-08-24", "expiration_date_range_start": "2019-08-24", "program_ids": [ … ], "program_restriction": "exclude", "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "renewal_reminder_options": { "application_types": [ … ], "program_ids": [ … ], "program_restriction": "exclude", "reminders": [ … ], "restrict_application_types": true, "restrict_status_reasons": true, "status_reason_ids": [ … ], "training_provider_ids": [ … ], "training_provider_restriction": "exclude" }, "run_date": "2019-08-24T14:15:22Z", "scheduled_preprocessing_date": "2019-08-24T14:15:22Z", "scheduled_run_date": "2019-08-24T14:15:22Z", "send_application_reminders": true, "send_renewal_reminders": true, "statistics": [ { … } ], "status": "cancelled", "sys_bulk_load_at": "string", "sys_bulk_load_id": "string", "sys_bulk_load_pk": "string", "sys_bulk_load_record_no": 0.1, "sys_bulk_load_source_file": "string", "sys_calculated_field_error": "string", "sys_calculated_field_errors": [ { … } ], "sys_configuration_snapshot_id": "string", "sys_created_at": "2019-08-24T14:15:22Z", "sys_created_by_id": "string", "sys_deleted_by_id": "string", "sys_directive": "string", "sys_external_id": "string", "sys_has_files_in_s3": true, "sys_last_bulk_data_operation_id": "string", "sys_last_bulk_data_operation_sys_version": "string", "sys_last_modified_at": "2019-08-24T14:15:22Z", "sys_last_modified_by_id": "string", "sys_last_security_context": {}, "sys_locked": true, "sys_snapshot_base_version": 0.1, "sys_version": 0.1, "template_id": "string", "training_provider_billing_options": { "email_invoices_to_training_providers": true, "expiration_date_range_end": "2019-08-24", "expiration_date_range_start": "2019-08-24", "invoice_template_id": "string", "payment_terms_id": "string", "program_ids": [ … ], "program_restriction": "exclude", "training_provider_ids": [ … ], "training_provider_restriction": "exclude" } }